*
* GDI+ Intro Part 3
*
* Example 3 - create thumbnail, method 2
*
#include ffc/gdiplus.h

* Initialise GDI+
createobject('ReportListener')

* Create thumbnail bitmap (method 2)
CreateThumbnail( ;
	'zoephoto.jpg', 'zoethumb3.jpg' ;
	, 120, 100 ;  && 120px x 100px
	, 0xFF66FF66 ; && light green
	)

* ================================================	
function CreateThumbnail( ;
	cSourceFilename as String ;
	, cThumbFilename as string ;
	, nThumbWidth as Integer ;
	, nThumbHeight as Integer ;
	, nBackgroundColor as Integer ;
	)
	
	local oSrcImage as GpImage of ffc/_gdiplus ;
		, oThumb as GpBitmap of ffc/_gdiplus ;
		, oGraphics as GpGraphics of ffc/_gdiplus

	oSrcImage = newobject('GpImage','ffc/_gdiplus')
	oSrcImage.CreateFromFile( cSourceFilename )
	
	* Create thumbnail with white background
	oThumb = newobject('GpBitmap', 'ffc/_gdiplus.vcx')
	oThumb.Create(m.nThumbWidth,m.nThumbHeight)
	oGraphics = newobject('GpGraphics','ffc/_gdiplus.vcx')
	oGraphics.CreateFromImage(m.oThumb)
	oGraphics.Clear( m.nBackgroundColor )

	* Determine size to scale bitmap to
	local nScaleFactor, nDrawX, nDrawY, nDrawnWidth, nDrawnHeight
	
	nScaleFactor = min( ;
		m.nThumbWidth/ oSrcImage.ImageWidth ;
		, m.nThumbHeight/oSrcImage.ImageHeight)
	nDrawnWidth = oSrcImage.ImageWidth*m.nScaleFactor
	nDrawnHeight = oSrcImage.ImageHeight*m.nScaleFactor

	* Position it centered on the bitmap
	nDrawX = (m.nThumbWidth-m.nDrawnWidth)/2
	nDrawY = (m.nThumbHeight-m.nDrawnHeight)/2
	
	* and draw it
	oGraphics.DrawImageScaled( oSrcImage ;
		, m.nDrawX ;
		, m.nDrawY ;
		, m.nDrawnWidth ;
		, m.nDrawnHeight )
		
	oThumb.SaveToFile( m.cThumbFilename, 'image/jpeg' )
endfunc