*
* GDI+ Intro Part 3
*
* Example 4 - detecting errors
*
#include ffc/gdiplus.h

* Initialise GDI+
createobject('ReportListener')

* Loading a bitmap into memory
local oImage as GpImage of ffc/_gdiplus.vcx
oImage = newobject('GpImage', 'ffc/_gdiplus.vcx')
oImage.CreateFromFile( 'zoephoto.jpg' )


* Write to write-protected file
* You must create the file and set the readonly attribute first!

if not oImage.SaveToFile( 'protected.jpg','image/jpeg' )
	if oImage.GetStatus() = GDIPLUS_STATUS_Win32Error
		messagebox( "Win32 error occurred: " ;
			+ ltrim(str(oImage.win32LastError)) )
	else
		messagebox( "GDI+ error occurred: " ;
			+ ltrim(str(oImage.GetStatus())) )
	endif
	* return or whatever
endif


* Try loading a file which does not exist
* Note this code gives a status code of 'out of memory' despite that
* you would think 'file not found' was more appropriate

if not oImage.CreateFromFile( 'flyingpigs.jpg' )
	if oImage.GetStatus() = GDIPLUS_STATUS_Win32Error
		messagebox( "Win32 error occurred: " ;
			+ ltrim(str(oImage.win32LastError)) )
	else
		messagebox( "GDI+ error occurred: " ;
			+ ltrim(str(oImage.GetStatus())) )
	endif
	* return or whatever
endif
